local s = SpellFlashAddon

local a = CreateFrame("Frame",nil,UIParent)
local guid, timestamp, amount
local seeker
local eventType
local tabTimestamps = {}
local tabHPLoss = {}
local latestStamp
local logging
local dps
local seconds
local currentHP

a:RegisterEvent("PLAYER_REGEN_ENABLED")
a:RegisterEvent("PLAYER_REGEN_DISABLED")
a:RegisterEvent("PLAYER_LOGIN")

local function stopLogging()
	a:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	wipe(tabTimestamps)
	wipe(tabHPLoss)
	logging = false
end

local function startLogging()
	a:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	logging = true
end

local function logDamage(...)
	timestamp, _, _, _, _, _, _, guid, _, _, _, _, _, _, amount = select(1, ...)
	if amount then
		latestStamp = timestamp
		seeker = tabTimestamps[guid]
		if seeker then
			tabHPLoss[guid] = tabHPLoss[guid] + amount
		else
			tabTimestamps[guid] = timestamp
			tabHPLoss[guid] = amount
		end
	end
end

local function logHealing(...)
	timestamp, _, _, _, _, _, _, guid, _, _, _, _, _, _, amount = select(1, ...)
	if amount then
		latestStamp = timestamp
		seeker = tabTimestamps[guid]
		if seeker then
			tabHPLoss[guid] = tabHPLoss[guid] - amount
		end
	end
end

function s.TimeToDie(unit)
	if not unit then
		unit = "target"
	end
	if  logging then
		guid = UnitGUID(unit)
		if guid then
			currentHP = UnitHealth(unit)
			seeker = tabTimestamps[guid]
			if currentHP == 0 then
				return 0
			elseif seeker then
				seconds = latestStamp - seeker
				if seconds > 0 then
					dps = tabHPLoss[guid] / seconds
--					print("TTD: ", currentHP / dps)
					return currentHP / dps
				end
			end
		end
	end
end

a:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_LOGIN" or event == "PLAYER_REGEN_ENABLED" then
		stopLogging()
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		eventType = select(2, ...)
		if eventType == "SPELL_DAMAGE" or eventType == "SWING_DAMAGE" or eventType == "DAMAGE_SHIELD" or eventType == "SPELL_PERIODIC_DAMAGE" or eventType == "SPELL_BUILDING_DAMAGE" or eventType == "RANGE_DAMAGE" then
			logDamage(...)
		elseif eventType == "SPELL_HEAL" or eventType == "SPELL_PERIODIC_HEAL" then
			logHealing(...)
		end
	else
		startLogging()
	end
end)